

#define Version "170520"

// le Timer2 est cal sur 20mS
//  chaque IT, il arme le timer1 pour 1  2mS suivant la valeur de Cde_Servo
// et Met la pulse Servo  1
// le Timer1 en fin de timing , remet  zero la pulse servo
// tout se passe dans les interruptions.
// la valeur de Cde_Servo provient de la mesure ADC EA1 (pin 18)
// qui est moyenne sur 4 (ou 8 ) valeurs , pour avoir une commande stable ( mais moins rapide)

// Theorie : Timer1 value= 64535 -> 1000S   et avec Timer1 value =  63535 --> 2000S
// valeurs mesuree : 0 -> 1,004 mS   500 -> 1,500mS    1,004 -> 2,004 mS
// Pratical value , adjusted to get exactly 1,0 to 2,0 mS
// calibration  64545 au lieu de 64535  soit delta =10 pts / 64545       soit 0,015%
// Cde_Servo=64545- Average_T;
// rajout interruption UART RX :
// Permet le Rajout diverses options de commande
// mode 0 : par consigne Potar connect sur EA1 (+Vref interne 4,096V)   alim MCU =4,8  5V
// mode 1 : par valeur tape au clavier KEY0  KEY 1000  ( evolution pulse de 1  2mS)
// 3 position fixes , evoluant  une vitesse reglable par la coammnde
// DLY0  DLY255 => reglage Tempo * 1mS
// mode 2: par cde MINI   valeur 1mS atteinte avec un pas evoluant toute les "Tempo" mS
// mode 3: par cde CENTRE   valeur 1,5mS atteinte avec un pas evoluant toute les "Tempo" mS
// mode 4: par cde MAXI   valeur 2mS atteinte avec un pas evoluant toute les "Tempo" mS

// mode BAVARD ou SILENCIEUX via cde  VERBOSE=1 ou VERBOSE=0
// le mode bavard penalise le temps de reaction !
/*
2017.05.20, 18:56:47.748, Move to MAXI ..
2017.05.20, 18:56:47.862, EA1=     1	Cde_Servo =   00.5%  MSB= FC LSB= 20
..... until
2017.05.20, 18:56:51.249, EA1=  1000	Cde_Servo =  100.0%  MSB= F8 LSB= 39
  soit ~4 secondes   en mode bavard et < 800mS en mode Silencieux

 */




//#define Version "170519"
// problemo
// ADC=0 -> 1,014 mS
// ADC=1000 -> 2,300 mS au lieu de 2,000mS ?? WHY
// le pPB etait sur le nb de boucle accumule et pas la bonne variable affichee !!
#define Directory "C:\\_MikroC\\_MesProjets_MikroC\\_16F1847_Test_Servo_JR_C507"
#define Projet "16F1847_ADC_Test_Servo_2017.mcppi"
#define Source "_16F1847_UART_ADC_Test_Servo_JR_C507"      // sans extension !
#define MCU "16F1847"
#define FOSC "Interne 8MHz"
#define POWER_SUPPLY "5V"

/*
FOSC interne 8 MHz ,  avec clockout enabled on RA6  ( 2Mhz)
P16F1847_Fosc_interne_8MHZ_clkout_RA6.cfgsch
CONFIG1 : $8007 : 0x31E4
CONFIG2 : $8008 : 0x1613

*/
 
 
 //-- commandes terminal VT220
#define CLS 12     // effacement de page sur Terminal VBRAY
#define CR 13
#define VT 10
#define LF 10
#define TAB 9
#define BELL 7
 
/// Hardware 16F1847  DIP18 :
/*
 -Alim 5V
PIN 1    RA2/AN2 DACOUT
PIN 2    RA3 AN3
PIN 3    RA4/AN4  output --> Led-1K--+5V
                    |-----750----------ICSP VPP  PIN 1 Pickit2
Pin 4     RA5/ MCLR |--- 6,2K --- +5V
Pin 5     VSS et ----------------------ICSP Gnd Pin 3  Pickit2
pin 7     RB1 SDA1 -------I2C bus  ----2,7K --+5V 
 ou
pin 7     RB1 RX
pin 8     RB2 TX  UART  <--- vert  <-- TX  Prolic 23023 PC COM
pin 9     RB3/AN9/ CCP1/P1A
-----
Pin 18    RA1/AN1  Analog in <--- 390 ohms <-- curseur potar 2,2K (entre +Vcc et Gnd)                                               EA1
Pin 17    RA0/AN0
Pin 16    RA7/OSC1/ClockIn
Pin 15    RA6/OSC2/ClockOut
pin 14    VDD +5V
pin 13    RB7/AN6--- 750 ------------- ICSPDAT   Pin 4   Pickit2
pin 12    RB6/AN5--- 750 ------------- ICSPCLCK  Pin 5   Pickit2
pin 11    RB5/AN5   UART ----> blanc  -> RX  Prolic 23023 PC COM
pin 10    RB4 SCL1 -----------I2C BUS ---2,7K --- +5V
  */

 
 //ac:Pinout_16F1847
  

char TEXTE[80];
char * txt;
char CRam1[64];

unsigned int i,j,k,l,m,n;

#define MAXLEN1 80
unsigned char buffer1[MAXLEN1];
unsigned int Index1=0;
unsigned int UART1_DataReady=0;
unsigned int i1=0;
unsigned char c1;
int CptErr;

sbit Pulse_Servo at PORTA.B4;
sbit Pulse_Servo_Direction at TRISA.B4;

unsigned int Tension;
unsigned int  Average_T;
unsigned int Old_Average_T;
unsigned int CptB=0;
unsigned int New_Tension;
unsigned int Tempo=1;

static unsigned int Cde_Servo=64035;
unsigned char * p1;   // pointeur sur valeur Cde_Servo
unsigned int Mode=0;  // choix 0=POTAR   1=KEYBOARD value  2=Mini  3=Millieu  4=Maxi
unsigned char * p2;   // pointeur sur zone buffer1
int Verbose=1;        // mode bavard par defaut
unsigned int Moving=0;



void Special_Init_UART1_RB2_RB5(void);
void RAZ_UART1(void) ;
void strConstRamCpy(char *dest, const char *source);
void UART1_Write_CText(const char *txt1)  ;
void CRLF1(void)     ;


void Interrupts() iv 0x0004 ics ICS_AUTO
{
  if ( (RCIE_bit) && ( RCIF_bit))
   {
    // pour debug reception car
    //   TXREG='@';
   // traitement separe des erreurs de COM
      if (RCSTA.OERR==1)    // voir parag 16.1.26 p273
      {
       RCSTA.CREN = 0 ;
       c1 = RCREG;
       RCSTA.CREN = 1 ;
       CptErr++;
       }
      if(RCSTA.FERR==1 )
      {
      RCSTA.SPEN = 0 ;
      RCSTA.SPEN= 1 ;
      CptErr++;
       c1 = RCREG;
      }
      c1 = RCREG;
     if (c1==CR)
      {
      UART1_DataReady=1;
      RCIE_bit=0 ; //interdit IT Reception UART
      buffer1[i1]=0;
      Index1=i1;
      i1=0;
      c1=0;
     }
     else
     {
        buffer1[i1]=c1;
        Index1=i1;
        i1++;
        if (i1>=MAXLEN1) i1=0;
      }
   }
  if ((TMR2IF_bit)&&(TMR2IE_bit))    // 20 mS
  {
    TMR1ON_bit=0;
    TMR2IF_bit = 0;
     p1=(unsigned char *) &Cde_Servo;
    TMR1H    =*(p1+1);  // Cde_Servo.H ; //0xFA;
    TMR1L    =*(p1);// Cde_Servo.B;
    TMR1IE_bit=1;
    TMR1ON_bit=1;
    TMR1IF_bit=0;  
    Pulse_Servo=1;

  }
  else
  {
    if ((TMR1IF_bit)&&(TMR1IE_bit))    // 1  2mS
   {
    Pulse_Servo=0;
    TMR1ON_bit=0;
    TMR1IF_bit = 0;
   }
  }
}



void RAZ_UART1()
{
      for (i1=0;i1<MAXLEN1;i1++) buffer1[i1]=0;
      Index1=0;
      i1=0;
      c1=RCREG;  // vide le buffer RCREG
      c1=0;
      UART1_DataReady=0;
     // REGISTER 8-2: PIE1: PERIPHERAL INTERRUPT ENABLE REGISTER 1
      RCIE_bit=1 ;
}

void UART1_Write_CText(const char *txt1)
 {
   while (*txt1)
      UART1_Write(*(txt1++));
}

// --- Copie le texte depuis ROM vers RAM
void strConstRamCpy(char *dest, const char *source)
 {
  while(*source) *(dest++) = *(source++) ;
  *dest = 0 ;    // terminateur
}

void CRLF1()
{
 UART1_Write(CR);
  UART1_Write(LF);
 }

void Read_Msg_Eeprom(unsigned char debut)
{   int i1 ;
unsigned char c;
  i1=debut;
  do
  {
  c = EEPROM_Read(i1);
  if ( c==0) break;
  if ( i1>254) break;
  UART1_Write(c);
  Delay_ms(5);
  i1++;
   }
  while (c!=0) ;
 }

void Special_Init_UART1_RB2_RB5(void)
{
  //DS41453B-page 120   RB2=RX  RB5=TX
 /* bit 7 RXDTSEL: Pin Selection bit
  0 = RX/DT function is on RB1
  1 = RX/DT function is on RB2  <------------
  bit 6 SDO1SEL: Pin Selection bit
  0 = SDO1 function is on RB2
  1 = SDO1 function is on RA6
  bit 5 SS1SEL: Pin Selection bit
      0 = SS1 function is on RB5
      1 = SS1 function is on RA5
      */

  APFCON0.SDO1SEL=1; //0 = SDO1 function is on RB2 , 1 = SDO1 function is on RA6
  APFCON0.SS1SEL=1;  // 1 = SS1 function is on RA5
  APFCON0.RXDTSEL=1; // 1 = RX/DT function is on RB2
  APFCON1.TXCKSEL=1;     // RB5 as TX UART
  BAUDCON.WUE=0;  //Wake-up Enable bit  0 = Receiver is operating normally
  CPSCON0 = 0 ;//CAPACTIVE SENSE MODULE OFF
  TRISB.B2=1;
 }


//Timer1
//Prescaler 1:2; TMR1 Preload = 64035; Actual Interrupt Time : 1,5 ms
void Init_Timer1()
{
  T1CON         = 0x01;
  // prescaler  1:2
  T1CON.T1CKPS1=0;
  T1CON.T1CKPS0=1;
  TMR1IF_bit         = 0;
  // 63535 => 2mS
  // 64035 => 1,5mS
  // 64535 => 1mS
  TMR1H         = *(p1+1); // Cde_Servo.H ; //0xFA;
  TMR1L         = *(p1); //Cde_Servo.B;
  TMR1IE_bit         = 0;
  INTCON         = 0xC0;
  T1CON.TMR1ON=0;
}


//Timer2
//Prescaler 1:16; Postscaler 1:10; TMR2 Preload = 250; Actual Interrupt Time : 20,005 ms
void Init_Timer2(){
  T2CON         = 0x4E;
  PR2                 = 250;
  TMR2IE_bit         = 0;
  INTCON         = 0xC0;
}

void Display_Timer1_Init_Value()
{  int PourCent;
   PourCent=Tension;
   WordToStr(PourCent,CRam1);
   *(CRam1+7)=0;
   *(CRam1+6)= *(CRam1+5);
   *(CRam1+5)= *(CRam1+4);
   *(CRam1+4)='.';
   if (PourCent<10)  *(CRam1+3)='0';
   if (PourCent<100)  *(CRam1+2)='0';
   UART1_Write_CText("Cde_Servo = ");
   if (PourCent==1000) *(CRam1+1)='1';
   UART1_Write_Text(CRam1);
   if (PourCent<10)  *(CRam1+1)='0';
   UART1_Write_CText("%  MSB= ");
   ByteToHex(*(p1+1),CRam1);
    UART1_Write_Text(CRam1);
   UART1_Write_CText(" LSB= ");
   ByteToHex(*(p1),CRam1);
   UART1_Write_Text(CRam1);
   CRLF1();
}

void main()
{
// FOSC interne
  OSCCON =  0b01110110 ; // Pll disable; Freq=8Mhz;
  OSCTUNE=0;

  TRISB  = 0b00000010;   // RB1 en entre
  TRISA  = 0b00000011;   // RA0,RA1 en entre le reste en sortie
  ANSELA = 0b00000011;  // RA0,RA1 en Analogique
  ANSELB = 0;           // PORTB en Digital

// output to drive servo moteur
  Pulse_Servo_Direction=0;
  Pulse_Servo=0;
  Mode=0;
  Verbose=1;
  Tempo=1;

  UART1_Init(19200);   // Initialisation de l'UART
  // par defaut TX sur RB2  et RX sur RB1
  
  Special_Init_UART1_RB2_RB5();
  Delay_ms(100);

  UART1_Write(CLS);
  Delay_ms(500);
   UART1_Write_CText("\r\n Presentation :\r\n");
   UART1_Write_CText(" Directory : "Directory"\r\n");
   UART1_Write_CText(" Projet : "Projet"\r\n");
   UART1_Write_CText(" PIC : "MCU"  FOSC:  "FOSC"\r\n");
   UART1_Write_CText(" Source MikroC 7.01 : "Source"_"Version".C\r\n");
 //  UART1_Write_CText(" Alimentation  "POWER_SUPPLY"\r\n");
   UART1_Write_CText(" Test ServoMoteur Graupner JR C507\r\n");
   UART1_Write_CText(" Timer2 used for 20mS timing periode\r\n");
   UART1_Write_CText(" Timer1 used for pulse 1 up to 2 mSec\r\n");
   CRLF1();
   Delay_ms(1000);
   
   // valeur theorique
   //Cde_Servo=64035;  // 1,5mS Timer1
   // valeur pratique
   Cde_Servo=64049;  // 1,5mS Timer1
   p1=(unsigned char *) &Cde_Servo;
   Init_Timer1();
   Display_Timer1_Init_Value();
   
  
  UART1_Write_CText("\r\nInit ADC voie RA1 Ch1 avec +VREF interne +4.096V  \r\n");
  C1ON_bit = 0;    // Dsactive les comparateurs
  C2ON_bit = 0;
  CPSCON0=0;
  ADC_Init_Advanced(_ADC_INTERNAL_FVRH4);
  Tension=0;
  ADCON0=0b00000101;
 // ADCON0.ADON=1;     // validation ADC
  Delay_ms(10);
  Old_Average_T=Average_T=0;
  
  Init_Timer1();
  Init_Timer2();
  TMR2IE_bit         = 1;
  TMR1IE_bit         = 0;
  TMR1IF_bit=0;
  TMR2IF_bit=0;
  
   RAZ_UART1();
  
   // INTCON  =  Rglages des interruptions
  RCIE_bit = 1;            // INT sur Rx UART activ
  PEIE_bit  = 1;           // INT pripheriques Activ
  GIE_bit   = 1;           // INT Global activ
  CptB=0;
  j=0;
  while(1)
  {
  // selection du mode de commande 
  if (Mode==0)
   {  // commande via potentiometre
        Tension=ADC_Get_Sample(1);
    }
   if (Tension > 1000)
   {
    Tension=1000;
    }
   Average_T=Average_T + Tension;
   if (j >=8)
    { 
      Average_T= Average_T >> 3;  // moyenne des 8 valeurs accumules
      if (Average_T!=Old_Average_T )
      {
       // theorique value
       // Cde_Servo=64535- Average_T;
       // Pratical value , adjusted to get exactly 1,0 to 2,0 mS
       Cde_Servo=64545- Average_T;
       Old_Average_T=Average_T;
      // if(Moving==1)
      // {
      // UART1_Write('@');
      // CRLF1();
      // Moving=0;
      // }
       if(Verbose==1)
       {
       UART1_Write_CText("EA1= ");
       WordToStr(Average_T,CRam1);
       UART1_Write_Text(CRam1);
       UART1_Write(TAB);
       Display_Timer1_Init_Value();
       }
      }
      j=0;
      Average_T=0;
      if((CptB==0) && (Verbose==0)) Display_Timer1_Init_Value();
      CptB++;
   }
    j++;

   // --- test liaison terminal -----------
   if( UART1_DataReady==1)
   {
     CRLF1();
     #ifdef DEBUGGING
     UART1_Write_CText(buffer1);
    CRLF1();
    #endif
    p2=strstr(buffer1,"POT");
    if(p2>0)
    {
    UART1_Write_CText("Commande Via Potar sur EA1\r\n");
    CRLF1();
     Mode=0;
     p2=0;
    }
    p2=strstr(buffer1,"KEY");
    if (p2>0)
       { 
         Mode=1;
         k=strlen(buffer1);
         if((k>3) && (k<8))
         {
           #ifdef DEBUGGING
           // test si tous les digits sont des chiffres
          CRLF1();UART1_Write_Text(buffer1+3);CRLF1();
          #endif
          m=0;
          for (i=0;i<(k-3);i++)
          {
             if ((*(buffer1+3+i)>='0')&&(*(buffer1+3+i)<='9'))  m++;
          }
          if (m==(k-3))
          {
          n= atoi(buffer1+3);
          #ifdef DEBUGGING
            UART1_Write_CText("\r\n m= ");
            WordToStr(n,CRam1);
            UART1_Write_Text(CRam1);CRLF1();
          #endif
           if ((n>=0)&&(n<=1000)) New_Tension=n;
           UART1_Write_CText("\r\nChange Consigne to ");
           WordToStr(Tension,CRam1);
           UART1_Write_Text(CRam1);
           CRLF1();
          }
          else
           UART1_Write_CText("Error saisie Consigne : \"KEY0  KEY1000\"\r\n");
         }
         p2=0;
      }
      
      p2=strstr(buffer1,"DLY");     // DLY0  255
      if (p2>0)
       {
         k=strlen(buffer1);
         if((k>3) && (k<7))
         {
           #ifdef DEBUGGING
           // test si tous les digits sont des chiffres
          CRLF1();UART1_Write_Text(buffer1+3);CRLF1();
          #endif
          m=0;
          for (i=0;i<(k-3);i++)
          {
             if ((*(buffer1+3+i)>='0')&&(*(buffer1+3+i)<='9'))  m++;
          }
          if (m==(k-3))
          {
          n= atoi(buffer1+3);
          #ifdef DEBUGGING
            UART1_Write_CText("\r\n m= ");
            WordToStr(n,CRam1);
            UART1_Write_Text(CRam1);CRLF1();
          #endif
           if ((n>=0)&&(n<=255)) Tempo=n;
           UART1_Write_CText("\r\nChange Delay to ");
           WordToStr(Tempo,CRam1);
           UART1_Write_Text(CRam1);
           CRLF1();
          }
          else
           UART1_Write_CText("Error saisie DLY0  DLY255\r\n");
         }
         p2=0;
      }
     
      p2=strstr(buffer1,"MINI");
      if (p2>0)
       {
         Mode=2;
         New_Tension=0;
         UART1_Write_CText("Move to MINI ..\r\n");
         p2=0;
      }
     
      p2=strstr(buffer1,"CENTRE");
      if (p2>0)
       {
         Mode=3;
         New_Tension=500;
          UART1_Write_CText("Move to CENTER..\r\n");
         p2=0;
       }
     
      p2=strstr(buffer1,"MAXI");
      if (p2>0)
       {
         Mode=4;
         UART1_Write_CText("Move to MAXI ..\r\n");
         New_Tension=1000;
         p2=0;
      }
     
       p2=strstr(buffer1,"VERBOSE=");      // VERBOSE=1
       if (p2>0)
        {
          if (*(buffer1+8)=='1')
          {
           UART1_Write_CText("Mode BAVARD activ ..Verbose=1\r\n");
           Verbose=1;
           }
          else
          {
           Verbose=0;
           UART1_Write_CText("Mode SILENCIEUX Verbose=0..\r\n") ;
         }
        p2=0;
       }
    RAZ_UART1();
   }
   
   
    switch(Mode)
   { case 0:
       // commande via potentiometre
        Delay_ms(1);
        break;
    case 1:
       // cde directe par valeur Keyboard  KEY0 to KEY1000
        if (New_Tension> Tension)   Tension++;
        if (New_Tension<Tension)    Tension --;
        if ((New_Tension!=Tension) && (Moving==0))  Moving=1;
        if ((New_Tension==Tension) && (Moving==1))
        {
           UART1_Write('*'); CRLF1();
           Moving=0;
        }
        i=Tempo;
        while(i>0){ Delay_ms(1); i--;}
       break;
    default:
   // mini, centre,maxi
        if (New_Tension> Tension)   Tension++;
        if (New_Tension<Tension)    Tension --;
        if ((New_Tension!=Tension) && (Moving==0))  Moving=1;
        if ((New_Tension==Tension) && (Moving==1))  
        {
           UART1_Write('$'); CRLF1();
           Moving=0;
        }
       i=Tempo;
        while(i>0){ Delay_ms(1); i--;}
      break;
    }
  }
}


/*

EA1=  1000      TMR1 = 63545 MSB= F8 LSB= 39
EA1=   500      TMR1 = 64045 MSB= FA LSB= 2D
EA1=     0      TMR1 = 64545 MSB= FC LSB= 21

Presentation :
 Directory : C:\_MikroC\_MesProjets_MikroC\_16F1847_Test_Servo_JR_C507
 Projet : 16F1847_ADC_Test_Servo_2017.mcppi
 PIC : 16F1847  FOSC:  Interne 8MHz
 Source MikroC 7.01 : _16F1847_UART_ADC_Test_Servo_JR_C507_170520.C
 Alimentation  5V
 Test ServoMoteur Graupner JR C507
 Timer2 used for 20mS timing periode
 Timer1 used for pulse 1 up to 2 mSec

Cde_Servo =  100.0%  MSB= FA LSB= 31

Init ADC voie RA1 Ch1 avec +VREF interne +4.096V
EA1=  1125      Cde_Servo =  100.0%  MSB= F7 LSB= BC
Cde_Servo =  100.0%  MSB= F7 LSB= BC
EA1=  1000      Cde_Servo =  100.0%  MSB= F8 LSB= 39

EA1=     0      Cde_Servo =   00.0%  MSB= FC LSB= 21
EA1=     1      Cde_Servo =   00.1%  MSB= FC LSB= 20

EA1=    26      Cde_Servo =   0.26% MSB= FC LSB= 07
EA1=    27      Cde_Servo =   0.27% MSB= FC LSB= 06
EA1=    28      Cde_Servo =   0.28% MSB= FC LSB= 05

EA1=    95      Cde_Servo =   0.95% MSB= FB LSB= C2
EA1=    96      Cde_Servo =   0.97% MSB= FB LSB= C1
EA1=    98      Cde_Servo =   0.99% MSB= FB LSB= BF
EA1=   102      Cde_Servo =   1.03% MSB= FB LSB= BB

EA1=   129      Cde_Servo =   1.29% MSB= FB LSB= A0
EA1=   131      Cde_Servo =   1.32% MSB= FB LSB= 9E

EA1=   456      Cde_Servo =   46.0%  MSB= FA LSB= 59
EA1=   474      Cde_Servo =   48.1%  MSB= FA LSB= 47
EA1=   498      Cde_Servo =   50.2%  MSB= FA LSB= 2F
EA1=   502      Cde_Servo =   52.0%  MSB= FA LSB= 2B
EA1=   542      Cde_Servo =   54.5%  MSB= FA LSB= 03

EA1=   951      Cde_Servo =   95.1%  MSB= F8 LSB= 6A
EA1=   952      Cde_Servo =   95.3%  MSB= F8 LSB= 69
EA1=   953      Cde_Servo =   95.4%  MSB= F8 LSB= 68
EA1=   954      Cde_Servo =   95.4%  MSB= F8 LSB= 67
EA1=   960      Cde_Servo =   96.1%  MSB= F8 LSB= 61
EA1=   964      Cde_Servo =   96.6%  MSB= F8 LSB= 5D
EA1=   968      Cde_Servo =   96.9%  MSB= F8 LSB= 59
EA1=   976      Cde_Servo =   97.7%  MSB= F8 LSB= 51
EA1=   986      Cde_Servo =   98.7%  MSB= F8 LSB= 47
EA1=   993      Cde_Servo =   99.4%  MSB= F8 LSB= 40
EA1=   999      Cde_Servo =  100.0%  MSB= F8 LSB= 3A
EA1=  1000      Cde_Servo =  100.0%  MSB= F8 LSB= 39

 Presentation :
 Directory : C:\_MikroC\_MesProjets_MikroC\_16F1847_Test_Servo_JR_C507
 Projet : 16F1847_ADC_Test_Servo_2017.mcppi
 PIC : 16F1847  FOSC:  Interne 8MHz
 Source MikroC 7.01 : _16F1847_UART_ADC_Test_Servo_JR_C507_170520.C
 Alimentation  5V

TMR1 = 64049 MSB= FA LSB= 31

Init ADC voie RA1 Ch1 avec +VREF interne +4.096V
EA1=   531      TMR1 = 64014 MSB= FA LSB= 0E
TMR1 = 64014 MSB= FA LSB= 0E
EA1=   499      TMR1 = 64046 MSB= FA LSB= 2E
EA1=   497      TMR1 = 64048 MSB= FA LSB= 30
EA1=   499      TMR1 = 64046 MSB= FA LSB= 2E

MINI
EA1=   995      Cde_Servo =   99.2%  MSB= F8 LSB= 3E
EA1=   987      Cde_Servo =   98.4%  MSB= F8 LSB= 46
EA1=   979      Cde_Servo =   97.6%  MSB= F8 LSB= 4E
EA1=   971      Cde_Servo =   96.8%  MSB= F8 LSB= 56
 ...
 EA1=    11      Cde_Servo =   00.8%  MSB= FC LSB= 16
EA1=     3      Cde_Servo =   00.0%  MSB= FC LSB= 1E
EA1=     0      Cde_Servo =   00.0%  MSB= FC LSB= 21
Cde_Servo =   00.0%  MSB= FC LSB= 21








0 1 mikroCPIC1618.exe -MSF -DBG -pP16F1847 -RA -C -O11111004 -fo8 -N"
C:\_MikroC\_MesProjets_MikroC\_16F1847_Test_Servo_JR_C507\16F1847_ADC_Test_Servo_2017.mcppi" -SP"
C:\_MikroC\mikroC PRO for PIC\Defs\" -SP"
C:\_MikroC\mikroC PRO for PIC\Uses\P16_Enh\" -SP"
C:\_MikroC\_MesProjets_MikroC\_16F1847_Test_Servo_JR_C507\" -SP"
C:\_MikroC\_MesProjets_MikroC\common\" -SP"
C:\_MikroC\_MesProjets_MikroC\_16F1847_2xDS18B20_LCD_2x16_I2C\" -IP"
C:\_MikroC\_MesProjets_MikroC\_16F1847_Test_Servo_JR_C507\" "_16F1847_UART_ADC_Test_Servo_JR_C507_170520.c" "
__Lib_Math.mcl" "
__Lib_MathDouble.mcl" "
__Lib_System.mcl" "
__Lib_Delays.mcl" "
__Lib_CType.mcl" "
__Lib_CString.mcl" "
__Lib_CStdlib.mcl" "
__Lib_Conversions.mcl" "
__Lib_ADC.mcl" "
__Lib_EEPROM.mcl" "
__Lib_UART_b21.mcl"
0 1139 Available RAM: 1008 [bytes], Available ROM: 8192 [bytes]
0 122 Compilation Started P16F1847.c
1400 123 Compiled Successfully P16F1847.c
0 122 Compilation Started
__Lib_Delays.c
123 123 Compiled Successfully
__Lib_Delays.c
0 122 Compilation Started _16F1847_UART_ADC_Test_Servo_JR_C507_170520.c
0 1004 interrupt handler (Interrupts at 0x0004) _16F1847_UART_ADC_Test_Servo_JR_C507_170520.c
293 1509 Generated baud rate is 19231 bps (error = 0.16 percent) _16F1847_UART_ADC_Test_Servo_JR_C507_170520.c
387 123 Compiled Successfully _16F1847_UART_ADC_Test_Servo_JR_C507_170520.c
0 127 All files Compiled in 63 ms
0 1144 Used RAM (bytes): 199 (20%)  Free RAM (bytes): 809 (80%) Used RAM (bytes): 199 (20%)  Free RAM (bytes): 809 (80%)
0 1144 Used ROM (program words): 1324 (16%)  Free ROM (program words): 6868 (84%) Used ROM (program words): 1324 (16%)  Free ROM (program words): 6868 (84%)
0 125 Project Linked Successfully 16F1847_ADC_Test_Servo_2017.mcppi
0 128 Linked in 31 ms
0 129 Project '16F1847_ADC_Test_Servo_2017.mcppi' completed: 266 ms
0 103 Finished successfully: 20 mai 2017, 12:54:37 16F1847_ADC_Test_Servo_2017.mcppi

*/